-- DCS LUA SCRIPT FOR THE FLYPT HEXAPOD INTERFACE
-- Copy this file to the folder %USER%/Saved Games/DCS/Scripts/Export.lua
-- If the Scripts folder doesn't exist, create it.

function LuaExportStart()
    package.path = package.path..";.\\LuaSocket\\?.lua"
    package.cpath = package.cpath..";.\\LuaSocket\\?.dll"
    socket = require("socket")
    host = host or "127.0.0.1"
    port = port or 4123
    c = socket.udp()
    c:settimeout(0)
    c:setpeername(host, port)
end

function LuaExportAfterNextFrame()
    local acceleration = LoGetAccelerationUnits() -- In g's
    local pitch, roll, yaw = LoGetADIPitchBankYaw() -- In radians
    -- Yaw output from 0 to 2*PI
    -- Roll and Pitch from -PI to PI
    --LoGetTrueAirSpeed() -- In m/s
    --LoGetModelTime() -- In s
    if c then
        -- The FlyPT Interface uses Z for vertical and Y to the front
        -- That's the opposite in DCS
        -- Besides that, vertical acceleration includes gravity, so we subtract 1 from the value (gravity is already present just by you sitting in the rig)
        socket.try(c:send(string.format("%.4f %.4f %.4f %.4f %.4f %.4f %.4f %.4f", acceleration.x, acceleration.z, acceleration.y - 1, yaw, roll, pitch, LoGetTrueAirSpeed(), LoGetModelTime())))
    end
end

function LuaExportStop()
    if c then
        c:close()
    end
end